/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-07 19:00:49 UTC)
 * on 2013-08-13 at 18:50:20 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.books.model;

/**
 * Model definition for BooksAnnotationsRange.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BooksAnnotationsRange extends com.google.api.client.json.GenericJson {

  /**
   * The offset from the ending position.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String endOffset;

  /**
   * The ending position for the range.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String endPosition;

  /**
   * The offset from the starting position.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String startOffset;

  /**
   * The starting position for the range.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String startPosition;

  /**
   * The offset from the ending position.
   * @return value or {@code null} for none
   */
  public java.lang.String getEndOffset() {
    return endOffset;
  }

  /**
   * The offset from the ending position.
   * @param endOffset endOffset or {@code null} for none
   */
  public BooksAnnotationsRange setEndOffset(java.lang.String endOffset) {
    this.endOffset = endOffset;
    return this;
  }

  /**
   * The ending position for the range.
   * @return value or {@code null} for none
   */
  public java.lang.String getEndPosition() {
    return endPosition;
  }

  /**
   * The ending position for the range.
   * @param endPosition endPosition or {@code null} for none
   */
  public BooksAnnotationsRange setEndPosition(java.lang.String endPosition) {
    this.endPosition = endPosition;
    return this;
  }

  /**
   * The offset from the starting position.
   * @return value or {@code null} for none
   */
  public java.lang.String getStartOffset() {
    return startOffset;
  }

  /**
   * The offset from the starting position.
   * @param startOffset startOffset or {@code null} for none
   */
  public BooksAnnotationsRange setStartOffset(java.lang.String startOffset) {
    this.startOffset = startOffset;
    return this;
  }

  /**
   * The starting position for the range.
   * @return value or {@code null} for none
   */
  public java.lang.String getStartPosition() {
    return startPosition;
  }

  /**
   * The starting position for the range.
   * @param startPosition startPosition or {@code null} for none
   */
  public BooksAnnotationsRange setStartPosition(java.lang.String startPosition) {
    this.startPosition = startPosition;
    return this;
  }

  @Override
  public BooksAnnotationsRange set(String fieldName, Object value) {
    return (BooksAnnotationsRange) super.set(fieldName, value);
  }

  @Override
  public BooksAnnotationsRange clone() {
    return (BooksAnnotationsRange) super.clone();
  }

}
